#ifndef _FS_CONVERT_C_H_
#define _FS_CONVERT_C_H_

#ifdef __cplusplus
extern "C" {
#endif



typedef enum _FSHTML2PDFPageMode {
e_FSPageModeSinglePage  = 0,
e_FSPageModeMultiplePage = 1,
}FSHTML2PDFPageMode;



typedef enum _FSHTML2PDFScalingMode {
e_FSScalingModeNone  = 0,
e_FSScalingModeScale = 1,
e_FSScalingModeEnlarge = 2,
}FSHTML2PDFScalingMode;



typedef enum _FSHTML2PDFEncodingFormat {
e_FSEncodingFormatDefault  = 0,
e_FSEncodingFormatASCII = 1,
e_FSEncodingFormatLatin2 = 2,
e_FSEncodingFormatLatin3  = 3,
e_FSEncodingFormatLatin4 = 4,
e_FSEncodingFormatLatin5  = 5,
e_FSEncodingFormatLatin6 = 6,
e_FSEncodingFormatISO_8859_5 = 7,
e_FSEncodingFormatArabic = 8,
e_FSEncodingFormatGreek = 9,
e_FSEncodingFormatHebrew = 10,
e_FSEncodingFormatEUC_JP = 11,
e_FSEncodingFormatSJS  = 12,
e_FSEncodingFormatJIS = 13,
e_FSEncodingFormatBIG5 = 14,
e_FSEncodingFormatGB  = 15,
e_FSEncodingFormatEUC_CN = 16,
e_FSEncodingFormatKSC = 17,
e_FSEncodingFormatUnicode  = 18,
e_FSEncodingFormatEUC = 19,
e_FSEncodingFormatCNS = 20,
e_FSEncodingFormatBIG5_CP950  = 21,
e_FSEncodingFormatASCII_7_bit = 22,
e_FSEncodingFormatKOI8R = 23,
e_FSEncodingFormatCP852 = 24,
e_FSEncodingFormatCP866 = 25,
e_FSEncodingFormatCP874 = 26,
e_FSEncodingFormatCP932 = 27,
e_FSEncodingFormatCP1250  = 28,
e_FSEncodingFormatCP1251  = 29,
e_FSEncodingFormatCP1252 = 30,
e_FSEncodingFormatCP1253  = 31,
e_FSEncodingFormatCP1254 = 32,
e_FSEncodingFormatCP1255 = 33,
e_FSEncodingFormatCP1256  = 34,
e_FSEncodingFormatCP1257  = 35,
e_FSEncodingFormatKOI8U = 36,
e_FSEncodingFormatISO_8859_15 = 37,
e_FSEncodingFormatISO_8859_11 = 38,
e_FSEncodingFormatISO_8859_8_I = 39,
e_FSEncodingFormatVISUAL  = 40,
e_FSEncodingFormatCSN_369103 = 41,
e_FSEncodingFormatISO_8859_13 = 42,
e_FSEncodingFormatISO_2022_KR  = 43,
e_FSEncodingFormatGBK = 44,
e_FSEncodingFormatGB18030 = 45,
e_FSEncodingFormatBIG5_HKSCS  = 46,
e_FSEncodingFormatISO_2022_CN = 47,
e_FSEncodingFormatTSCII = 48,
e_FSEncodingFormatTAM  = 49,
e_FSEncodingFormatTAB = 50,
e_FSEncodingFormatJAGRAN = 51,
e_FSEncodingFormatMACINTOSH  = 52,
e_FSEncodingFormatUTF7 = 53,
e_FSEncodingFormatBHASKAR = 54,
e_FSEncodingFormatHTCHANAKYA  = 55,
e_FSEncodingFormatUTF_16BE = 56,
e_FSEncodingFormatUTF_16LE = 57,
e_FSEncodingFormatUTF_32BE  = 58,
e_FSEncodingFormatUTF_32LE = 59,
e_FSEncodingFormatX_BINARYENC = 60,
e_FSEncodingFormatHZ_GB_2312  = 61,
e_FSEncodingFormatX_UTF8UTF8 = 62,
e_FSEncodingFormatX_TAM_ELANGO = 63,
e_FSEncodingFormatX_TAM_LTTMBARANI = 64,
e_FSEncodingFormatX_TAM_SHREE = 65,
e_FSEncodingFormatX_TAM_TBOOMIS = 66,
e_FSEncodingFormatX_TAM_TMNEWS = 67,
e_FSEncodingFormatX_TAM_WEBTAMIL  = 68,
e_FSEncodingFormatX_KDDI_Shift_JIS = 69,
e_FSEncodingFormatX_DoCoMo_Shift_JIS = 70,
e_FSEncodingFormatX_SoftBank_Shift_JIS  = 71,
e_FSEncodingFormatX_KDDI_ISO_2022_JP = 72,
e_FSEncodingFormatX_SoftBank_ISO_2022_JP = 73,
}FSHTML2PDFEncodingFormat;



typedef enum _FSHTML2PDFMediaStyle {
e_FSMediaStyleScreen  = 0,
e_FSMediaStylePrint  = 1,
}FSHTML2PDFMediaStyle;


struct FSHTML2PDFSettingData {
  float page_width;
  float page_height;
  FS_BOOL is_to_page_scale;
  FSRectF page_margin;
  FSRotation rotate_degrees;
  FS_BOOL is_convert_link;
  FS_BOOL is_generate_tag;
  FSHTML2PDFPageMode page_mode;
  FS_BOOL to_generate_bookmarks;
  FSHTML2PDFScalingMode scaling_mode;
  FSHTML2PDFEncodingFormat encoding_format;
  FS_BOOL to_render_images;
  FS_BOOL to_remove_underline_for_link;
  FS_BOOL to_set_headerfooter;
  FS_WSTR headerfooter_title;
  FS_WSTR headerfooter_url;
  FS_WSTR bookmark_root_name;
  FS_BOOL to_resize_objects;
  FS_BOOL to_print_background;
  FS_BOOL to_optimize_tag_tree;
  FSHTML2PDFMediaStyle media_style;
};

struct FSTXT2PDFSettingData {
  float page_width;
  float page_height;
  FSRectF page_margin;
  FS_FONT_HANDLE font;
  float text_size;
  FS_ARGB text_color;
  float linespace;
  FS_BOOL is_break_page;
};


typedef enum _FSConvertOptimizeOption {
e_FSConvertOptimizeOptionForPrint  = 0,
e_FSConvertOptimizeOptionForOnScreen = 1,
}FSConvertOptimizeOption;



typedef enum _FSConvertContentOption {
e_FSConvertContentOptionOnlyContent  = 0,
e_FSConvertContentOptionWithMarkup = 1,
}FSConvertContentOption;



typedef enum _FSConvertBookmarkOption {
e_FSConvertBookmarkOptionNone  = 0,
e_FSConvertBookmarkOptionUseHeadings = 1,
e_FSConvertBookmarkOptionUseWordBookmark = 2,
}FSConvertBookmarkOption;


struct FSWord2PDFSettingData {
  FS_BOOL include_doc_props;
  FSConvertOptimizeOption optimize_option;
  FSConvertContentOption content_option;
  FSConvertBookmarkOption bookmark_option;
  FS_BOOL convert_to_pdfa;
};


typedef enum _FSConvertQuality {
e_FSConvertQualityStandard  = 0,
e_FSConvertQualityMinimum = 1,
}FSConvertQuality;



typedef enum _FSScaleType {
e_FSScaleTypeNone  = 0,
e_FSScaleTypeFitAllColumns = 1,
e_FSScaleTypeFitAllRows = 2,
e_FSScaleTypeFitSheet = 3,
}FSScaleType;


struct FSExcel2PDFSettingData {
  FS_BOOL include_doc_props;
  FSConvertQuality quality;
  FS_BOOL ignore_print_area;
  FSScaleType scale_type;
  FS_BOOL convert_to_pdfa;
};


typedef enum _FSConvertIntent {
e_FSConvertIntentPrint  = 0,
e_FSConvertIntentScreen = 1,
}FSConvertIntent;



typedef enum _FSHandoutOrder {
e_FSHandoutOrderHorizontalFirst  = 0,
e_FSHandoutOrderVerticalFirst = 1,
}FSHandoutOrder;



typedef enum _FSOutputType {
e_FSOutputSlides = 1,
e_FSOutputNotesPages = 2,
e_FSOutputOutline = 3,
e_FSOutputOneSlideHandouts = 4,
e_FSOutputTwoSlideHandouts = 5,
e_FSOutputThreeSlideHandouts = 6,
e_FSOutputFourSlideHandouts = 7,
e_FSOutputSixSlideHandouts = 8,
e_FSOutputNineSlideHandouts = 9,
}FSOutputType;


struct FSPowerPoint2PDFSettingData {
  FSConvertIntent intent;
  FS_BOOL frame_output_slides;
  FSOutputType output_type;
  FSHandoutOrder handout_order;
  FS_BOOL output_hidden_slides;
  FS_BOOL include_doc_props;
};

struct FSHTML2PDFRelatedResource {
  FSReaderCallback* related_resource_file;
  FS_WSTR resource_file_relative_path;
};

FSErrorCode FSDK_Convert_FromHTML(const wchar_t* src_html, const wchar_t* engine_path, const wchar_t* cookies_path, const FSHTML2PDFSettingData& setting_data, const wchar_t* saved_pdf_path, FS_INT32 timeout);
FSErrorCode FSDK_Convert_FromHTML0(const wchar_t* src_html, const wchar_t* engine_path, FSReaderCallback* cookies_reader, const FSHTML2PDFSettingData& setting_data, const wchar_t* saved_pdf_path, FS_INT32 timeout);
FSErrorCode FSDK_Convert_FromHTML1(const wchar_t* src_html, const wchar_t* engine_path, FSReaderCallback* cookies_reader, const FSHTML2PDFSettingData& setting_data, FSWriterCallback* saved_pdf_filestream, FS_INT32 timeout);
FSErrorCode FSDK_Convert_FromHTML2( FSReaderCallback* src_html, const FSHTML2PDFRelatedResource* related_resource_array, FS_UINT32 array_length_html2pdf_related_resource_array, const wchar_t* engine_path, FSReaderCallback* cookies_reader, const FSHTML2PDFSettingData& setting_data, FSWriterCallback* saved_pdf_filestream, FS_INT32 timeout);
FSErrorCode FSDK_Convert_FromTXT(const wchar_t* src_txt, const wchar_t* saved_pdf_path, const FSTXT2PDFSettingData& setting_data);
FSErrorCode FSDK_Convert_FromWord(const wchar_t* src_word_file_path, const wchar_t* src_file_password, const wchar_t* saved_pdf_path, const FSWord2PDFSettingData& setting_data);
FSErrorCode FSDK_Convert_FromExcel(const wchar_t* src_excel_file_path, const wchar_t* src_file_password, const wchar_t* saved_pdf_path, const FSExcel2PDFSettingData& setting_data);
FSErrorCode FSDK_Convert_FromPowerPoint(const wchar_t* src_ppt_file_path, const wchar_t* src_file_password, const wchar_t* saved_pdf_path, const FSPowerPoint2PDFSettingData& setting_data);
FSErrorCode FSDK_Convert_ToXML(const wchar_t* src_pdf_path, const wchar_t* src_file_password, const wchar_t* saved_xml_path, const wchar_t* saved_image_folder_path, FS_BOOL is_force_to_tagged_pdf, FS_BOOL& return_value);
#ifdef __cplusplus
}
#endif
#endif
